/*
 File: fsm_phrase_th.cpp
 Date and Time: Fri Jan 30 18:55:12 2015 
*/
#include "fsm_phrase_th.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_fsm_phrase_th;// grammar's ns
// first set terminals
fsm_rules_reuse_table_type::fsm_rules_reuse_table_type(){
 no_rules_entries_ = 30;
 per_rule_s_table_[0] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[1] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[2] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[3] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[4] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[5] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[6] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[7] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[8] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[9] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[10] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[11] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[12] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[13] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[14] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[15] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[16] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[17] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[18] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[19] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[20] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[21] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[22] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[23] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[24] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[25] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[26] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[27] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[28] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[29] =  new Per_rule_s_reuse_table();
}
  Cfsm_phrase_th::
  Cfsm_phrase_th()
    :yacco2::CAbs_fsm
      ("fsm_phrase_th.lex"
      ,"1.0"
      ,"11 mar 2004"
      ,false
      ,"Parse grammar's fsm phrase along with its directives."
      ,"Fri Jan 30 18:55:12 2015 "
      ,S1_Cfsm_phrase_th){
    
    fsm_phrase_ = 0;
  
  }
 
Cfsm_phrase_th::~Cfsm_phrase_th(){

  for(int x = 0;x < 30;++x){
   ///delete fsm_rules_reuse_table.per_rule_s_table_[x];
  }
} 

  bool Cfsm_phrase_th::failed(){
      return false;
  }
  void Cfsm_phrase_th::op(){
    if(fsm_phrase_ != 0){
      delete fsm_phrase_;
      fsm_phrase_ = 0;
    }
    fsm_phrase_ = new T_fsm_phrase;
    fsm_phrase_->set_rc(*parser__->start_token__,__FILE__,__LINE__);
    AST* t = new AST(*fsm_phrase_);
    fsm_phrase_->phrase_tree(t);
    if(CWEB_MARKER != 0){
      fsm_phrase_->add_cweb_marker(CWEB_MARKER);
      CWEB_MARKER = 0;
    }
  
}
int Cfsm_phrase_th::rhs_to_rules_mapping_[73] = {
 -1
 ,0 // subrule 1 for rule 1
 ,1 // subrule 2 for rule 2
 ,1 // subrule 3 for rule 2
 ,2 // subrule 4 for rule 3
 ,2 // subrule 5 for rule 3
 ,3 // subrule 6 for rule 4
 ,4 // subrule 7 for rule 5
 ,5 // subrule 8 for rule 6
 ,5 // subrule 9 for rule 6
 ,5 // subrule 10 for rule 6
 ,6 // subrule 11 for rule 7
 ,6 // subrule 12 for rule 7
 ,6 // subrule 13 for rule 7
 ,7 // subrule 14 for rule 8
 ,7 // subrule 15 for rule 8
 ,8 // subrule 16 for rule 9
 ,8 // subrule 17 for rule 9
 ,8 // subrule 18 for rule 9
 ,9 // subrule 19 for rule 10
 ,9 // subrule 20 for rule 10
 ,9 // subrule 21 for rule 10
 ,10 // subrule 22 for rule 11
 ,10 // subrule 23 for rule 11
 ,11 // subrule 24 for rule 12
 ,11 // subrule 25 for rule 12
 ,11 // subrule 26 for rule 12
 ,12 // subrule 27 for rule 13
 ,12 // subrule 28 for rule 13
 ,12 // subrule 29 for rule 13
 ,13 // subrule 30 for rule 14
 ,13 // subrule 31 for rule 14
 ,14 // subrule 32 for rule 15
 ,14 // subrule 33 for rule 15
 ,14 // subrule 34 for rule 15
 ,15 // subrule 35 for rule 16
 ,15 // subrule 36 for rule 16
 ,16 // subrule 37 for rule 17
 ,16 // subrule 38 for rule 17
 ,17 // subrule 39 for rule 18
 ,17 // subrule 40 for rule 18
 ,17 // subrule 41 for rule 18
 ,18 // subrule 42 for rule 19
 ,18 // subrule 43 for rule 19
 ,18 // subrule 44 for rule 19
 ,19 // subrule 45 for rule 20
 ,19 // subrule 46 for rule 20
 ,20 // subrule 47 for rule 21
 ,20 // subrule 48 for rule 21
 ,20 // subrule 49 for rule 21
 ,21 // subrule 50 for rule 22
 ,21 // subrule 51 for rule 22
 ,21 // subrule 52 for rule 22
 ,22 // subrule 53 for rule 23
 ,22 // subrule 54 for rule 23
 ,23 // subrule 55 for rule 24
 ,23 // subrule 56 for rule 24
 ,23 // subrule 57 for rule 24
 ,24 // subrule 58 for rule 25
 ,24 // subrule 59 for rule 25
 ,24 // subrule 60 for rule 25
 ,25 // subrule 61 for rule 26
 ,25 // subrule 62 for rule 26
 ,26 // subrule 63 for rule 27
 ,26 // subrule 64 for rule 27
 ,26 // subrule 65 for rule 27
 ,27 // subrule 66 for rule 28
 ,27 // subrule 67 for rule 28
 ,27 // subrule 68 for rule 28
 ,28 // subrule 69 for rule 29
 ,28 // subrule 70 for rule 29
 ,29 // subrule 71 for rule 30
 ,29 // subrule 72 for rule 30
}; 
Rfsm_phrase::Rfsm_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_phrase",0,Cfsm_phrase_th::R_Rfsm_phrase_,P,false,false){
}

void Rfsm_phrase::sr1(){
  
      Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
      RSVP(fsm->fsm_phrase_);
      fsm->fsm_phrase_ = 0;
    
}

Ropen_par::Ropen_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Ropen_par",0,Cfsm_phrase_th::R_Ropen_par_,P,false,false){
}

void Ropen_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_open_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclose_par::Rclose_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclose_par",0,Cfsm_phrase_th::R_Rclose_par_,P,false,false){
}

void Rclose_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rparameters::Rparameters(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rparameters",0,Cfsm_phrase_th::R_Rparameters_,P,false,false){
}

Rfsm_id_phrase::Rfsm_id_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_id_phrase",0,Cfsm_phrase_th::R_Rfsm_id_phrase_,P,false,false){
}

Rfsm_id::Rfsm_id(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_id",0,Cfsm_phrase_th::R_Rfsm_id_,P,false,false){
}

void Rfsm_id::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
       RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_id::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
       RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_id_name::Rfsm_id_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_id_name",0,Cfsm_phrase_th::R_Rfsm_id_name_,P,false,false){
}

void Rfsm_id_name::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->fsm_id(sf->p2__);
      
}

void Rfsm_id_name::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_id_name::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_id_string;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_filename_phrase::Rfsm_filename_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_filename_phrase",0,Cfsm_phrase_th::R_Rfsm_filename_phrase_,P,false,false){
}

void Rfsm_filename_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->start_token__,__FILE__,__LINE__);
       RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_filename::Rfsm_filename(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_filename",0,Cfsm_phrase_th::R_Rfsm_filename_,P,false,false){
}

void Rfsm_filename::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_filename_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_filename::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_filename_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_filename_name::Rfsm_filename_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_filename_name",0,Cfsm_phrase_th::R_Rfsm_filename_name_,P,false,false){
}

void Rfsm_filename_name::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->filename_id(sf->p2__);
      
}

void Rfsm_filename_name::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_filename_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_filename_name::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_filename_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_namespace_phrase::Rfsm_namespace_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_namespace_phrase",0,Cfsm_phrase_th::R_Rfsm_namespace_phrase_,P,false,false){
}

void Rfsm_namespace_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_namespace::Rfsm_namespace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_namespace",0,Cfsm_phrase_th::R_Rfsm_namespace_,P,false,false){
}

void Rfsm_namespace::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_namespace_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_namespace::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_namespace_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_namespace_name::Rfsm_namespace_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_namespace_name",0,Cfsm_phrase_th::R_Rfsm_namespace_name_,P,false,false){
}

void Rfsm_namespace_name::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->namespace_id(sf->p2__);
      
}

void Rfsm_namespace_name::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_namespace_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_namespace_name::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_namespace_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_class_phrase::Rfsm_class_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_class_phrase",0,Cfsm_phrase_th::R_Rfsm_class_phrase_,P,false,false){
}

void Rfsm_class_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_class::Rfsm_class(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_class",0,Cfsm_phrase_th::R_Rfsm_class_,P,false,false){
}

void Rfsm_class::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_class_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_class::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_class_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_class_name::Rfsm_class_name(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_class_name",0,Cfsm_phrase_th::R_Rfsm_class_name_,P,false,false){
}

void Rfsm_class_name::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_fsm_class_phrase* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->fsm_class_phrase(sf->p2__);
      
}

void Rfsm_class_name::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_version_phrase::Rfsm_version_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_version_phrase",0,Cfsm_phrase_th::R_Rfsm_version_phrase_,P,false,false){
}

void Rfsm_version_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_version::Rfsm_version(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_version",0,Cfsm_phrase_th::R_Rfsm_version_,P,false,false){
}

void Rfsm_version::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_version_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_version::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_version_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_version_string::Rfsm_version_string(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_version_string",0,Cfsm_phrase_th::R_Rfsm_version_string_,P,false,false){
}

void Rfsm_version_string::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->version(sf->p2__);
      
}

void Rfsm_version_string::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_version_string::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_version_string;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_date_phrase::Rfsm_date_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_date_phrase",0,Cfsm_phrase_th::R_Rfsm_date_phrase_,P,false,false){
}

void Rfsm_date_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_date::Rfsm_date(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_date",0,Cfsm_phrase_th::R_Rfsm_date_,P,false,false){
}

void Rfsm_date::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_date_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_date::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_date_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_date_string::Rfsm_date_string(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_date_string",0,Cfsm_phrase_th::R_Rfsm_date_string_,P,false,false){
}

void Rfsm_date_string::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->date(sf->p2__);
      
}

void Rfsm_date_string::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_date_string::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_date_string;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_debug_phrase::Rfsm_debug_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_debug_phrase",0,Cfsm_phrase_th::R_Rfsm_debug_phrase_,P,false,false){
}

void Rfsm_debug_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_debug::Rfsm_debug(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_debug",0,Cfsm_phrase_th::R_Rfsm_debug_,P,false,false){
}

void Rfsm_debug::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_debug_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_debug::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_debug_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_debug_string::Rfsm_debug_string(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_debug_string",0,Cfsm_phrase_th::R_Rfsm_debug_string_,P,false,false){
}

void Rfsm_debug_string::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        std::string x(sf->p2__->c_string()->c_str());
        std::string t("true");
        if(x == t){
          fsm->fsm_phrase_->debug(sf->p2__);
          return;
        }
        std::string f("false");
        if(x == f){
          fsm->fsm_phrase_->debug(sf->p2__);
          return;
        }
        CAbs_lr1_sym* sym = new Err_fsm_debug_string_not_true_or_false;
		sym->set_rc(*sf->p2__,__FILE__,__LINE__);
		RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_debug_string::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_debug_string::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_debug_string;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_comments_phrase::Rfsm_comments_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_comments_phrase",0,Cfsm_phrase_th::R_Rfsm_comments_phrase_,P,false,false){
}

void Rfsm_comments_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_comments::Rfsm_comments(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_comments",0,Cfsm_phrase_th::R_Rfsm_comments_,P,false,false){
}

void Rfsm_comments::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_fsm_comments_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfsm_comments::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_comments_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfsm_comments_string::Rfsm_comments_string(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfsm_comments_string",0,Cfsm_phrase_th::R_Rfsm_comments_string_,P,false,false){
}

void Rfsm_comments_string::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_c_string* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Cfsm_phrase_th* fsm = (Cfsm_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->fsm_phrase_->comment(sf->p2__);
      
}

void Rfsm_comments_string::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        RSVP(sf->p2__);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rfsm_comments_string::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_fsm_comments_string;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rlint::Rlint(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlint",0,Cfsm_phrase_th::R_Rlint_,P,false,false){
}

Rlint_epi::Rlint_epi(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlint_epi",0,Cfsm_phrase_th::R_Rlint_epi_,P,false,false){
}

